<?php
include_once __DIR__ . '/inc/dimox_breadcrumbs.php';
include_once __DIR__ . '/inc/kama_pagenavi.php';
//include_once __DIR__ . '/inc/shortcode.php';


//Удаляем category из УРЛа категорий тогда класс active  не добавится
add_filter( 'category_link', function($a){
	return str_replace( 'category/', '', $a );
}, 99 );



if ( function_exists('register_sidebars') ) {
    register_sidebar(array(
        'name'=>'Menu',
        'id' => 'right-sidebar',
        'before_widget' => '<div class="widget" >',
        'after_widget' => '</div>',
        'before_title' => '<div class="headwidget">',
        'after_title' => '</div>',
    ));
  }

add_theme_support( 'post-thumbnails' ); 

function cc_mime_types($mimes) {
    $mimes['svg'] = 'image/svg+xml';
    return $mimes;
}
add_filter('upload_mimes', 'cc_mime_types');


//дискрипшен автоматом
function kama_meta_description ($home_description='',$maxchar=200){
	global $wp_query,$post;
	if (is_singular()){
		if ( $descript = get_post_meta($post->ID, "description", true) )
			$out = $descript;
		elseif ($post->post_excerpt!='')
			$out = trim(strip_tags($post->post_excerpt));
		else
			$out = trim(strip_tags($post->post_content));

		$char = iconv_strlen( $out, 'utf-8' );
		if ( $char > $maxchar ) {
			 $out = iconv_substr( $out, 0, $maxchar, 'utf-8' );
			 $words = explode(' ', $out ); $maxwords = count($words) - 1; //убираем последнее слово, ибо оно в 99% случаев неполное
			 $out = join(' ', array_slice($words, 0, $maxwords)).' ...';
		 }
	}
	elseif (is_category() || is_tag()){
		$desc = $wp_query->queried_object->description;
		if ($desc) preg_match ('!\[description=(.*)\]!iU',$desc,$match);
		$out = $match[1]?$match[1]:'';
	}
	elseif (is_home()) $out=$home_description;
	if ($out){
		$out = str_replace( array("\n","\r"), ' ', strip_tags($out) );
		$out = preg_replace("@\[.*?\]@", '', $out); //удаляем шоткоды
		return print "<meta name='description' content='$out' />\n";
	}
	else return false;
}



/*** FIX Google PageSpeed Insights ***/
function footer_enqueue_scripts(){
    remove_action('wp_head','wp_print_scripts');
    remove_action('wp_head','wp_print_head_scripts',9);
    remove_action('wp_head','wp_enqueue_scripts',1);
    //add_action('wp_footer','wp_print_scripts',5);
    //add_action('wp_footer','wp_enqueue_scripts',5);
    //add_action('wp_footer','wp_print_head_scripts',5);
}
add_action('after_setup_theme','footer_enqueue_scripts');

add_action( 'init', function() {

    // Удалить конечную точку API REST..
    remove_action('rest_api_init', 'wp_oembed_register_route');

    // Turn off oEmbed auto discovery.
    // Не фильтровать полученные результаты..
    remove_filter('oembed_dataparse', 'wp_filter_oembed_result', 10);

    // Удалить oEmbed ссылки для обнаружения
    remove_action('wp_head', 'wp_oembed_add_discovery_links');

    // Удалить специфичный для oEmbed JavaScript из внешнего интерфейса и внутреннего интерфейса.
    remove_action('wp_head', 'wp_oembed_add_host_js');
}, PHP_INT_MAX - 1 );


//ограничиваем колличество ревизий(записей и страниц)
function my_revisions_to_keep( $revisions ) {
    return 1;
}
add_filter( 'wp_revisions_to_keep', 'my_revisions_to_keep' );

//подключаем шаблон single для категорий по SLUG например single-foto и тд
function singlecat( $t ) {
foreach( (array) get_the_category() as $cat )
{
if ( file_exists(TEMPLATEPATH . "/single-{$cat->slug}.php") ) return TEMPLATEPATH . "/single-{$cat->slug}.php";
}
return $t;
}
add_filter('single_template', 'singlecat' );


//count popular post
function setPostViews($postID) {
    $count_key = 'post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        $count = 0;
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
    }else{
        $count++;
        update_post_meta($postID, $count_key, $count);
    }
}
function getPostViews($postID){
    $count_key = 'post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
        return "0";
    }
    return $count;
}




/* увеличиваем время вылогирования */
add_filter( 'auth_cookie_expiration', 'login_time' );
 
function login_time( $expirein ) {
    return 31556926; // 1 год в секундах
}

//отключаем автоматическое обновление
add_filter( 'allow_dev_auto_core_updates', '__return_false' );

//получаем id страницы по ее названию
function wds_get_ID_by_page_name($page_name)
{
        global $wpdb;  
 $page_name = strip_tags($page_name);
 $page_name = addslashes($page_name);
        $page_name_id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_title ='".$page_name."'");
         return $page_name_id;
}
// выводим так
/* 
     $the_page_id = wds_get_ID_by_page_name('PAGE_NAME');
        echo $the_page_id;
*/










